set(BUILD_COMPILER "unknown")
set(BUILD_PLATFORM "unknown")
set(BUILD_TYPE "unknown")

if(WIN32)
  set(BUILD_PLATFORM "windows")
elseif(MINGW)
  set(BUILD_PLATFORM "mingw")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(BUILD_PLATFORM "darwin")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(BUILD_PLATFORM "linux")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Android")
  set(BUILD_PLATFORM "android")
elseif(CMAKE_SYSTEM_NAME STREQUAL "FreeBSD")
  set(BUILD_PLATFORM "freebsd")
elseif(CMAKE_SYSTEM_NAME STREQUAL "OpenBSD")
  set(BUILD_PLATFORM "openbsd")
elseif(CMAKE_SYSTEM_NAME STREQUAL "NetBSD")
  set(BUILD_PLATFORM "netbsd")
elseif(CMAKE_SYSTEM_NAME STREQUAL "iOS")
  set(BUILD_PLATFORM "ios")
endif()

# TODO: We should replace this with proper architecture detection like DetectArchitecture in luajit
if (CMAKE_SIZEOF_VOID_P MATCHES 8)
  set(BUILD_TYPE "x64")
elseif (CMAKE_SIZEOF_VOID_P MATCHES 4)
  set(BUILD_TYPE "x86")
endif ()

if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
  set(BUILD_COMPILER "gcc")
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
  set(BUILD_COMPILER "clang")
elseif(CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  set(BUILD_COMPILER "msvc")
endif()

message(STATUS "Build compiler: ${BUILD_COMPILER}")
message(STATUS "Build platform: ${BUILD_PLATFORM}")
message(STATUS "Build type: ${BUILD_TYPE}")
